<template>
  <div
    v-if="lazyLoad && !showMap"
    class="d-flex flex-column justify-content-center align-items-center w-100"
    style="height: 660px !important; z-index: 1"
  >
    <h4>Loading...</h4>
    <p class="text-muted font-size-20">Please wait while we load map data.</p>
    <v-progress-linear
      class="w-50"
      color="primary accent-4"
      indeterminate
      rounded
      height="6"
    ></v-progress-linear>
  </div>
  <div v-else class="map map-view bg-black-1 w-100 h-100 overflow-hidden">
    <l-map
      :options="mapOptions"
      class="leaflet-container leaflet-touch leaflet-fade-anim leaflet-grab leaflet-touch-drag leaflet-touch-zoom osm-grey-color"
      style="width: 100%; height: 100%"
      :zoom="zoom"
      :center="mapCenter"
      ref="mapObject"
    >
      <l-tile-layer :url="url" :attribution="attribution"></l-tile-layer>
      <l-polyline
        v-for="(polyline, index) in paths"
        :key="`p-${index}`"
        :lat-lngs="polyline"
      ></l-polyline>
      <l-marker
        v-for="(marker, index) in markers"
        :key="`m-${index}`"
        :lat-lng="marker"
        :icon="getMarker(index, markers.length)"
      >
      </l-marker>
    </l-map>
  </div>
</template>

<script>
import 'leaflet';
import 'leaflet/dist/leaflet.css';

import { LMap, LTileLayer, LPolyline, LMarker } from 'vue2-leaflet';
import { LatLng } from 'leaflet';
import { geometryLatLngFromLngLat } from '@/features/shuttlingTask/shuttlingService';
import L from 'leaflet';
import stopIcon from '@/assets/images/stop.svg';
import startIcon from '@/assets/images/start.svg';
import endIcon from '@/assets/images/end.svg';

export default {
  name: 'wiot-map',
  components: { LMap, LTileLayer, LPolyline, LMarker },
  props: {
    polylines: {
      type: Array,
      default: () => [],
    },
    markers: {
      type: Array,
      default: () => [],
    },
    center: {
      type: Array,
      default: () => [24, 54],
    },
  },
  mounted() {
    if (this.lazyLoad) {
      setTimeout(() => {
        this.showMap = true;
      }, 1000);
    } else {
      this.showMap = true;
    }
  },
  data: function () {
    return {
      lazyLoad: true,
      showMap: false,
      mapOptions: {
        zoomSnap: 0.1,
        zoomControl: false,
      },
      zoom: 12,
      url: 'https://api.mapbox.com/styles/v1/wathiq/cl8zmbk4p002l15mqxj481gco/tiles/512/{z}/{x}/{y}?access_token=sk.eyJ1Ijoid2F0aGlxIiwiYSI6ImNsOW1ieHlpdTB0cTUzd3FkZWloN2czM3UifQ.iBazlmAuJs85jcfJqYH3Vw',
      attribution:
        '&copy; <a href="http://www.openstreetmap.org/copyright">Wiot360</a> contributors',
    };
  },
  methods: {
    geometryLatLngFromLngLat,
    getMarker(index, length = 0) {
      if (index == 0) return this.startMarkerIcon;
      if (index == length - 1) return this.endMarkerIcon;
      else return this.stopMarkerIcon;
    },
  },
  computed: {
    mapCenter() {
      return new LatLng(...this.center);
    },
    paths() {
      return this.polylines.map((polyline) =>
        geometryLatLngFromLngLat(polyline)
      );
    },

    stopMarkerIcon() {
      return L.icon({
        iconUrl: stopIcon,
        iconSize: [50, 50],
        iconAnchor: [25, 50],
      });
    },
    startMarkerIcon() {
      return L.icon({
        iconUrl: startIcon,
        iconSize: [50, 50],
        iconAnchor: [25, 50],
      });
    },
    endMarkerIcon() {
      return L.icon({
        iconUrl: endIcon,
        iconSize: [50, 50],
        iconAnchor: [25, 50],
      });
    },
  },
  watch: {
    markers: {
      handler() {
        if (this.markers.length == 0) return;
        const bounds = L.latLngBounds(
          this.markers.map((marker) => L.latLng(...marker))
        );

        this.$refs.mapObject.fitBounds(bounds);
      },
      deep: true,
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
.map {
  height: 500px;
  width: 500px;
}
</style>
<style lang="scss">
.osm-grey-color .leaflet-tile-pane {
  filter: grayscale(1);
}

.leaflet-marker-icon {
  border-radius: 50%;
  -webkit-transition: opacity 7s ease-in-out;
  -moz-transition: opacity 7s ease-in-out;
  -o-transition: opacity 7s ease-in-out;
  transition: opacity 7s ease-in-out;

  @keyframes ripple {
    0% {
      box-shadow: 0 0 0 0px rgba(0, 0, 0, 0.2);
      backdrop-filter: brightness(0.9);
    }

    20% {
      box-shadow: 0 0 0 2px rgba(0, 0, 0, 0.2);
      backdrop-filter: brightness(0.8);
    }

    40% {
      box-shadow: 0 0 0 4px rgba(0, 0, 0, 0.2);
      backdrop-filter: brightness(0.7);
    }

    60% {
      box-shadow: 0 0 0 6px rgba(0, 0, 0, 0.2);
      backdrop-filter: brightness(0.8);
    }

    80% {
      box-shadow: 0 0 0 8px rgba(0, 0, 0, 0.2);
      backdrop-filter: brightness(0.9);
    }
  }

  &:hover {
    animation-name: ripple;
    animation-timing-function: ease-in-out;
    animation-iteration-count: infinite;
    animation-duration: 0.5s;
    animation-direction: alternate;
  }
}

.speedPlateContainer {
  position: absolute;
  right: 30px;
  top: 25px;
  z-index: 1;
}

.leaflet-popup-content {
  width: auto !important;
  margin: 0 !important;
}

.leaflet-control-zoom {
  margin-top: 30px !important;
}
.leaflet-container .leaflet-control-attribution {
  background: #fff;
  background: rgba(255, 255, 255, 0.8);
  margin: 0;
}
</style>
